/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *   @DM_Common_Def.h
 *   @version									0.1
 *   @brief										This file is the header file of defined common define and common enum type for using oma-dm-serice
 */

#ifndef OMA_DM_COMMON_DEF_H_
#define OMA_DM_COMMON_DEF_H_

/*#define _OMA_DM_V11_*/
#define _OMA_DM_V12_

#define _OMA_DM_DEBUG_
#ifdef _OMA_DM_DEBUG_
#define _OMA_DM_TEST_DEBUG
#endif

/*log tag define*/
/*
#define OMA_DM_LOG
#ifdef OMA_DM_LOG
	#define LOG_TAG "OMA_DM"
#endif
*/

//#define _DM_SCORE_TEST
#ifdef _DM_SCORE_TEST
#define _DM_BUNDANG_TEST
#endif

#define _SLP_SAMSUNG_DM_MO

/*
 * ==============================================
 *			OMA DM APP ID
 * ==============================================
 */
/*for bada*/
/*#define OMA_DM_FUMO_APPID "3b74c3e0075a630e"*/
/*for slp  fota*/

/*
#define OMA_DM_FUMO_APPID "xxxxxxxxxx"
#define OMA_DM_FUMO_APPSECRETID "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"

#define OMA_DM_LAWMO_APPID "xxxxxxxxxxxxxxxx"
#define OMA_DM_LAWMO_APPSECRETID "xxxxxxxxxxxxxxxxxxxxxxxxxxxx"
*/

/*
 * ==============================================
 *			OMA DM PKG DEFINE
 * ==============================================
 */
#define OMA_DM_AGENT_PKG "oma-dm-agent"
#define OMA_DM_FUMO_UI_PKG	"com.samsung.oma-dm"
#define OMA_DM_FUMO_NOTI_UI_PKG	"com.samsung.oma-dm-noti"
#define OMA_DM_ADMIN_UI_PKG	"com.samsung.oma-dm-admin"
#define OMA_DM_ALERT_UI_PKG	"com.samsung.oma-dm-alert"
#define OMA_DM_CP_UI_PKG		"com.samsung.oma-dm-cp"

/*
 * ==============================================
 *			OMA DM MSG
 * ==============================================
 */

#define OMA_DM_MSG_PATH "/tmp/dm.txt"

/*
 * ==============================================
 *			FUMO ENGINE DEFINE
 * ==============================================
 */
#define FUMO "fumo"
#define OMADM_FUMO_UI_TYPE "omadm_fota_ui"
#define OMADM_FUMO_NOTI_UI_TYPE "omadm_noti_ui"
#define OMADM_FUMO_BACKGROUND_UI_TYPE "omadm_background_ui"
#define OMADM_ADMIN_UI_TYPE "omadm_admin_ui"
#define OMADM_ALERT_UI_TYPE "omadm_alert_ui"
#define OMADM_CP_UI_TYPE "omadm_cp_ui"

#define FUMO_ACCOUNT_FLAG "fumo_account_flag"
#define FUMO_ACCOUNT_ALARM "fumo_account_alarm"
#define FUMO_ENGINE "fumo_engine"
#define FUMO_INTERVAL "fumo_interval"
#define FUMO_WIFI_ONLY_CONFIG "fumo_wifi_only_config"

#define LAWMO_ENGINE "lawmo_engine"
#define LAWMO_ACCOUNT_FLAG "lawmo_account_flag"
#define LAWMO_ACCOUNT_ALARM "lawmo_account_alarm"

#define FOTA_POLLING_ALARM "fumo_polling_alarm"
#define LAWMO_TRACKING_START_ALARM "lawmo_tracking_start_alarm"

#define IPC_DS														"/tmp/agent_fw_event_omads"
#define FOTA_DELTA_INTERNAL_STORAGE				"/opt/usr/data/fota"
#define FOTA_DELTA_SD_INTERNAL_STORAGE			"/opt/media"
#define FOTA_DELTA_SD_EXTERNAL_STORAGE		"/opt/storage/sdcard"

typedef enum {
	//INTERVAL_NONE =0,
	INTERVAL_1HOUR = 1,
	INTERVAL_3HOURS = 2,
	INTERVAL_6HOURS = 3,
	INTERVAL_12HOURS = 4,
	INTERVAL_1DAY = 5,
	//INTERVAL_7DAYS = 5,
	INTERVAL_CANCEL = 6,
	INTERVAL_1MONTH = 7
} Reminder_Interval;

typedef enum {
	FUMO_INTERVAL_TYPE = 0,	//alarm
	FUMO_WIFI_ONLY_TYPE = 1,
	FUMO_ACCOUNT_FLAG_TYPE = 2,
	FUMO_ACCOUNT_ALARM_TYPE = 3,	//alarm
	LAWMO_ACCOUNT_FLAG_TYPE = 4,
	LAWMO_ACCOUNT_ALARM_TYPE = 5,	//alarm
	FOTA_POLLING_ALARM_TYPE = 6,
	LAWMO_TRACKING_START_ALARM_TYPE = 7
} CONFIG_TYPE;

/*
 * ==============================================
 *			OMA DM ENGINE STATUS
 * ==============================================
*/

typedef enum {
	DM_IDLE = 0,
	DM_BEFORE_BOOTSTRAP = 1,
	DM_COMMON_PROCESSING = 2,
	DM_GENERIC_ALERT = 3,
	DM_SERVICE_ENGINE_PROCESSING = 4,

	/*todo */
	/*DM_FUMO_ENGINE_PROCESSING = 4,
	   DM_LAWMO_ENGINE_PROCESSING = 5,
	   DM_COMPLETE_FIRMWARE_UPDATE_WITH_GENERICALERT, */

	/*after 50 */
	DM_UI_DISPLAY,
	DM_UI_CONFIRMATION,
	DM_UI_USER_INPUT,
	DM_UI_USER_CHOISE,
	DM_UI_PROGRESS_BAR,

} ENGINE_STATUS;

/*
 * ==============================================
 *			SERVICE ENGINE STATUS
 * ==============================================
*/

typedef enum {
	DM_SERVICE_UNKNOWN = 0,
	DM_SERVICE_ING = 1,
	DM_GENERICALERT_ING = 2
/*	DM_SERVICE_ALARM = 3,
	DM_SERVICE_OTHER = 4*/
} SERVICE_ENGINE_STATUS;

/*
 * ==============================================
 *			ENGINE ID
 * ==============================================
*/

typedef enum {
	IDLE_ENGINE = 0,
	BOOTSTRAP = 1,
	COMMON_ENGINE = 2,
	GENERICALERT = 3,
	//SERVICE_ENGINE = 4,

	//sync_agent_dm_mo_type_e MAPPING
	FUMO_SERVICE_ENGINE = 4,
	LAWMO_SERVICE_ENGINE = 8,
	//SCOMO_SERVICE_ENGINE = 16,
	NO_SERVICE_ENGINE = 32
} ENGINE_ID;

/*
 * ==============================================
 *			ENGINE TYPE
 * ==============================================
*/

typedef enum {
	SAMSUNG_FUMO_TYPE = 4,
	SAMSUNG_FMM_TYPE = 8,
	GCF_TYPE = 16,
	NO_ENGINE_TYPE = 32
} SERVICE_SERVER_TYPE;

/*
 * ==============================================
 *			DM OPERATION MODE
 * ==============================================
*/

typedef enum {
	OPER_UNKNOWN,
	OPER_SERVER_INITIATION_FROM_WAP,
	OPER_SERVER_INITIATION_FROM_IP,
	OPER_USER_INITIATION,
	OPER_SCHEDULER
} OPER_MODE;

/*
 * ==============================================
 *			MEMORY TYPE
 * ==============================================
*/
typedef enum {
	MEMORY_INTERNAL,
	MEMORY_SD_CARD
} MEMORY_TYPE;

/*
 * ==============================================
 *			USER INTERACTION OPTION
 * ==============================================
*/

#define UI_OP_MINDT "MINDT="
#define UI_OP_MAXDT "MAXDT="
#define UI_OP_DR "DR="
#define UI_OP_MAXLEN "MAXLEN="
#define UI_OP_IT "IT="
#define UI_OP_ET "ET="
#define UI_OP_SEPARATOR "&"
#define UI_OP_EQUAL "="

/*
 * ==============================================
 *			RESUME STATES DOWNLOAD, INSTALL, LATER
 * ==============================================
*/

typedef enum {
	RESUME_STATUS_DONWLOAD_BEFORE = 0,
	RESUME_STATUS_DOWNLOAD,
	RESUME_STATUS_DOWNLOAD_LATER,
	RESUME_STATUS_DOWNLOAD_IDLE,
	RESUME_STATUS_INSTALL_BEFORE,
	RESUME_STATUS_INSTALL,
	RESUME_STATUS_INSTALL_LATER,
	RESUME_STATUS_INSTALL_IDLE
} RESUME_STATUS;

#endif				/* OMA_DM_COMMON_DEF_H_ */
