/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DM_CP_PARSER_H_
#define DM_CP_PARSER_H_

/*dm-agent*/
#include "dm_cp_struct.h"

typedef enum {
	CP_TYPE_XML = 1,
	CP_TYPE_WBXML,
	CP_TYPE_NONE
} CP_TYPE;

typedef enum {
	TNDS_TAG_CHARACTERISTIC_START
} CP_TAG;

/**
 * @par Description: API to parsing cp stream
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par par Method of function operation:
 * @par Important notes:
 * @param[in]		cp type
 * @param[in]		wbxml
 * @param[in]		msg size
 *
 * @return		DM_CP (cp structure)
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
DM_CP *parsing_cp_stream(CP_TYPE cp_type, const char *wbxml_stream, unsigned int msgSize);

#endif				/* DM_CP_PARSER_H_ */
