/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *   @DM_Error.h
 *   @version									0.1
 *   @brief										This file is the header file of defined fota account
 */

#ifndef FOTA_ACCOUNT_H_
#define FOTA_ACCOUNT_H_

#define VERSION_URL_KEY "db/SyncML/oma-dm-service/versionurl"
#define VERSION_FILENAME_KEY "db/SyncML/oma-dm-service/versionfilename"

/*dm-agent*/
#include "common/dm_error.h"

/**
 * @par Description: API to register fota account
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]
 * @param[out]
 *
 * @return				1 success
 *							0 error
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int register_fota_account();

int register_fota_polling(char *str_url, char *file_name, int *exist_version);

#endif				/* FOTA_ACCOUNT_H_ */
