/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *   @DM_Error.h
 *   @version									0.1
 *   @brief										This file is the header file of defined lawmo account
 */
#ifndef LAWMO_ACCOUNT_H_
#define LAWMO_ACCOUNT_H_

/*dm-agent*/
#include "common/dm_error.h"

/**
 * @par Description: API to register lawmo account
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			1	success
 *						0 error
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int register_lawmo_account(int item_id, void *user_data);

/**
 * @par Description: API to deregister lawmo account
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			1	success
 *						0	error
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int deregister_lawmo_account(int item_id, void *user_data);

#endif				/* LAWMO_ACCOUNT_H_ */
