/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef LAWMO_ENGINE_INTERNAL_H_
#define LAWMO_ENGINE_INTERNAL_H_

typedef enum {

	FULLY_LOCKED,		//the device is in Fully Locked state.
	PARTIALLY_LOCKED,	//The device is in Partially Locked state.
	UNLOCKED		//The device is in Unlocked state.
} LAWMO_State;

typedef enum {
	OPERATION_SUCCEEDED = 1200,
	WIPE_OPEARTION_SUCCEEDED_WITH_DATA_WIPED = 1201,
	WIPE_OPERATION_SUCCEEDED_WITH_BOTH_DATA_AND_ASSOCIATED_WIPE_LIST_WITHIN_MANAGEMENT_TREE_WIPED = 1202,

	/*SUCCESSFUL = VENDOR SPECIFIED */

	CLIENT_ERROR = 1400,
	USER_CANCELLED = 1401,
	FULLY_LOCK_DEVICE_FAILED = 1402,
	PARTIALLY_LOCK_DEVICE_FAILED = 1403,
	UNLOCK_DEVICE_FAILED = 1404,
	WIPE_DEVICES_DATA_FAILED = 1405,
	WIPE_OPERATION_NOT_PERFORMED = 1406
	    /*CLIENT ERROR = VENDOR SPECIFIED */
} LAWMO_Result_code;

#endif				/* LAWMO_ENGINE_INTERNAL_H_ */
