/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DM_PLATFORM_EVENT_HANDLER_H_
#define DM_PLATFORM_EVENT_HANDLER_H_

/*dm-agent*/
#include "framework/platform-event-handler/dm_platform_event_handler_internal.h"

/**
 * @par Description: API to dm wap push incomming callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int dm_wap_push_incomming_callback(int item_id, void *user_data);

/**
 * @par Description: API to dm wap push operation callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int dm_wap_push_operation_callback(int item_id, void *user_data);

/**
 * @par Description: API to dm ip push callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int dm_ip_push_callback(int item_id, void *user_data);

/**
 * @par Description: API to telephony incomming callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int dm_telephony_incomming_callback(int item_id, void *user_data);

/**
 * @par Description: API to telephony end callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]	item id
 * @param[in]	user data
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int dm_telephony_end_callback(int item_id, void *user_data);

/**
 * @par Description: API to network on callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 *
 * @return			DM_OK							success
 * 					DM_ERRORS					fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int network_on_callback();

/**
 * @par Description: API to network off callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 *
 * @return			1				success
 * 					0				fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int network_off_callback();

/**
 * @par Description: API to network change callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 *
 * @return			1				success
 * 					0				fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int network_change_callback();

/**
 * @par Description: API to alarm_callback
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 *
 * @return			1				success
 * 					0				fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int alarm_callback(int item_id, void *user_data);

/**
 * @par Description: API to event_data_free
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 *
 * @param[in]	event data
 *
 * @return
 *
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
void event_data_free(void *pEvent_data);

#endif				/* DM_PLATFORM_EVENT_HANDLER_H_ */
