/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DM_PLATFORM_EVENT_HANDLER_INTERNAL_H_
#define DM_PLATFORM_EVENT_HANDLER_INTERNAL_H_

typedef enum {
	IP_PUSH_EVENT = 0,
	WAP_PUSH_EVENT,
	UI_EVENT,
	SERVER_BOOTSTRAP_EVENT,
	POLL_EVENT
} Event_Type;

typedef enum {
	NOTI_TYPE_NOT_SPECIFIED = 0,
	NOTI_TYPE_BACKGRUOUND,
	NOTI_TYPE_INFOMATIVE,
	NOTI_TYPE_USERINTERACTION,
	NOTI_TYPE_POLLINTERACTION
} NotI_Type;

typedef struct {
	Event_Type type;
	char *session_id;
	char *server_id;
	NotI_Type noti_type;
	char *ui_mode;
} Event_Contents;

#endif				/* DM_PLATFORM_EVENT_HANDLER_INTERNAL_H_ */
