/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DM_MO_GENERATER_INTERNAL_H_
#define DM_MO_GENERATER_INTERNAL_H_

/*dm-agent*/
#include "common/dm_common_def.h"

#define MO_ROOT														"."
#define MO_SEPERATOR													"/"

#define DM_ACC_SERVICE												"DMAcc"
#define DEVINFO_SERVICE												"DevInfo"
#define DEVDETAIL_SERVIC												"DevDetail"
#define FUMO_SERVICE													"FUMO"
#define LAWMO_SERVICE												"LAWMO"
#define SCOMO_SERVICE												"SCOMO"

#define DM_DEVINFO													"./DevInfo"
#define DM_DEVDETAIL													"./DevDetail"
#define DM_DEVDETAIL_FWV											"./DevDetail/FwV"

#define DM_DMACC_MSCSERVER											"./DMAcc/MSCserver"
#define DM_DMACC_MSCTESTSERVER										"./DMAcc/MSCTestserver"
#define DM_DMACC_GCF												"./DMAcc/gcf"

#define DM_FUMO_STATE														"./FUMO/State"
#define DM_FUMO_DOWNLOAD_OP											"/Download"
#define DM_FUMO_UPDATE_OP											"/Update"
#define DM_FUMO_DOWNLOADAND_UPDATE_OP								"/DownloadAndUpdate"
#define DM_FUMO_DWONLOAD_OP_PKGURL									"/PkgURL"
#define DM_FUMO_UPDATE_PKG_OP_DATA									"/PkgData"
#define DM_FUMO_DOWNLOADAND_UPDATE_OP_PKGURL						"/PkgURL"
#define DM_FUMO_STATE_OP												"/State"
#define DM_FUMO_EXT_OP												"/Ext"

#define DM_FUMO_EXT_OP_DOCHECKINGROOTING						"/Ext/DoCheckingRooting"

#define DM_LAWMO_STATE_OP													"/State"
#define DM_LAWMO_AVAILABLEWIPELIST_LISTITEMNAME				"/AvailableWipeList/omadm/ListItemName"
#define DM_LAWMO_AVAILABLEWIPELIST_TOBEWIPED					"/AvailableWipeList/omadm/ToBeWipe"
#define DM_LAWMO_LAWMOCONFIG_NOTIFYUSER						"/Operations/LAWMOConfig/NotifyUser"
#define DM_LAWMO_OPERATIONS_FULLYLOCK_OP						"/Operations/FullllyLock"
#define DM_LAWMO_OPERATIONS_PARTIALLYLOCK_OP				"/Operations/PartiallyLock"
#define DM_LAWMO_OPERATIONS_UNLOCK_OP							"/Operations/UnLock"
#define DM_LAWMO_OPERATIONS_FACTORYRESET_OP					"/Operations/FactoryReset"
#define DM_LAWMO_OPERATIONS_WIPE_OP								"/Operations/Wipe"
#define DM_LAWMO_EXT															"/Ext"

typedef struct _dm_acc {
	char *profile_name;
	char *server_url;
	char *server_id;
	char *server_pw;
	char *user_id;
	char *user_pw;
	char *user_auth_type;
	char *server_auth_type;
	int base64;
	char *user_nextNonce;
	char *server_nextNonce;
} dm_acc;

/* this is temp code for test */
#ifndef _SLP_SAMSUNG_DM_MO

#define FUMO_DM_ACC														"./DMAcc"
#define FUMO_DM_ACC_FUMO											"./DMAcc/fumo"
#define FUMO_DM_ACC_APPID											"./DMAcc/fumo/AppID"
#define FUMO_DM_ACC_SERVERID										"./DMAcc/fumo/ServerID"
#define FUMO_DM_ACC_NAME												"./DMAcc/fumo/Name"
#define FUMO_DM_ACC_PRECONREF										"./DMAcc/fumo/PreConRef"
#define FUMO_DM_ACC_TOCONREF										"./DMAcc/fumo/ToConRef"
#define FUMO_DM_ACC_TOCONREF_X									"./DMAcc/fumo/ToConRef/MSC"
#define FUMO_DM_ACC_TOCONREF_X_CONREF						"./DMAcc/fumo/ToConRef/MSC/ConRef"
#define FUMO_DM_ACC_APPADDR											"./DMAcc/fumo/AppAddr"
#define FUMO_DM_ACC_APPADDR_X										"./DMAcc/fumo/AppAddr/MSC"
#define FUMO_DM_ACC_APPADDR_X_ADDR							"./DMAcc/fumo/AppAddr/MSC/Addr"
#define FUMO_DM_ACC_APPADDR_X_ADDRTYPE					"./DMAcc/fumo/AppAddr/MSC/AddrType"
#define FUMO_DM_ACC_APPADDR_X_PORT							"./DMAcc/fumo/AppAddr/MSC/Port"
#define FUMO_DM_ACC_APPADDR_X_PORT_X						"./DMAcc/fumo/AppAddr/MSC/Port/MSC"
#define FUMO_DM_ACC_APPADDR_X_PORT_X_PORTNBR			"./DMAcc/fumo/AppAddr/MSC/Port/MSC/PortNbr"
#define FUMO_DM_ACC_AAUTHPREF										"./DMAcc/fumo/AAuthPref"
#define FUMO_DM_ACC_APPAUTH											"./DMAcc/fumo/AppAuth"
#define FUMO_DM_ACC_APPAUTH_X1									"./DMAcc/fumo/AppAuth/ClientAppAuth"
#define FUMO_DM_ACC_APPAUTH_X1_AAUTHLEVEL				"./DMAcc/fumo/AppAuth/ClientAppAuth/AAuthLevel"
#define FUMO_DM_ACC_APPAUTH_X1_AAUTHTYPE					"./DMAcc/fumo/AppAuth/ClientAppAuth/AAuthType"
#define FUMO_DM_ACC_APPAUTH_X1_AAUTHNAME				"./DMAcc/fumo/AppAuth/ClientAppAuth/AAuthName"
#define FUMO_DM_ACC_APPAUTH_X1_SECRET						"./DMAcc/fumo/AppAuth/ClientAppAuth/AAuthSecret"
#define FUMO_DM_ACC_APPAUTH_X1_AAUTHDATA					"./DMAcc/fumo/AppAuth/ClientAppAuth/AAuthData"
#define FUMO_DM_ACC_APPAUTH_X2									"./DMAcc/fumo/AppAuth/ServerAppAuth"
#define FUMO_DM_ACC_APPAUTH_X2_AAUTHLEVEL				"./DMAcc/fumo/AppAuth/ServerAppAuth/AAuthLevel"
#define FUMO_DM_ACC_APPAUTH_X2_AAUTHTYPE					"./DMAcc/fumo/AppAuth/ServerAppAuth/AAuthType"
#define FUMO_DM_ACC_APPAUTH_X2_AAUTHNAME				"./DMAcc/fumo/AppAuth/ServerAppAuth/AAuthName"
#define FUMO_DM_ACC_APPAUTH_X2_SECRET						"./DMAcc/fumo/AppAuth/ServerAppAuth/AAuthSecret"
#define FUMO_DM_ACC_APPAUTH_X2_AAUTHDATA					"./DMAcc/fumo/AppAuth/ServerAppAuth/AAuthData"
#define FUMO_DM_ACC_EXT													"./DMAcc/fumo/Ext"

#define LAWMO_DM_ACC														"./DMAcc"
#define LAWMO_DM_ACC_LAWMO											"./DMAcc/lawmo"
#define LAWMO_DM_ACC_APPID												"./DMAcc/lawmo/AppID"
#define LAWMO_DM_ACC_SERVERID										"./DMAcc/lawmo/ServerID"
#define LAWMO_DM_ACC_NAME												"./DMAcc/lawmo/Name"
#define LAWMO_DM_ACC_PRECONREF										"./DMAcc/lawmo/PreConRef"
#define LAWMO_DM_ACC_TOCONREF										"./DMAcc/lawmo/ToConRef"
#define LAWMO_DM_ACC_TOCONREF_X									"./DMAcc/lawmo/ToConRef/MSC"
#define LAWMO_DM_ACC_TOCONREF_X_CONREF						"./DMAcc/lawmo/ToConRef/MSC/ConRef"
#define LAWMO_DM_ACC_APPADDR											"./DMAcc/lawmo/AppAddr"
#define LAWMO_DM_ACC_APPADDR_X										"./DMAcc/lawmo/AppAddr/MSC"
#define LAWMO_DM_ACC_APPADDR_X_ADDR							"./DMAcc/lawmo/AppAddr/MSC/Addr"
#define LAWMO_DM_ACC_APPADDR_X_ADDRTYPE					"./DMAcc/lawmo/AppAddr/MSC/AddrType"
#define LAWMO_DM_ACC_APPADDR_X_PORT							"./DMAcc/lawmo/AppAddr/MSC/Port"
#define LAWMO_DM_ACC_APPADDR_X_PORT_X						"./DMAcc/lawmo/AppAddr/MSC/Port/MSC"
#define LAWMO_DM_ACC_APPADDR_X_PORT_X_PORTNBR			"./DMAcc/lawmo/AppAddr/MSC/Port/MSC/PortNbr"
#define LAWMO_DM_ACC_AAUTHPREF										"./DMAcc/lawmo/AAuthPref"
#define LAWMO_DM_ACC_APPAUTH											"./DMAcc/lawmo/AppAuth"
#define LAWMO_DM_ACC_APPAUTH_X1									"./DMAcc/lawmo/AppAuth/ClientAppAuth"
#define LAWMO_DM_ACC_APPAUTH_X1_AAUTHLEVEL				"./DMAcc/lawmo/AppAuth/ClientAppAuth/AAuthLevel"
#define LAWMO_DM_ACC_APPAUTH_X1_AAUTHTYPE					"./DMAcc/lawmo/AppAuth/ClientAppAuth/AAuthType"
#define LAWMO_DM_ACC_APPAUTH_X1_AAUTHNAME				"./DMAcc/lawmo/AppAuth/ClientAppAuth/AAuthName"
#define LAWMO_DM_ACC_APPAUTH_X1_SECRET						"./DMAcc/lawmo/AppAuth/ClientAppAuth/AAuthSecret"
#define LAWMO_DM_ACC_APPAUTH_X1_AAUTHDATA					"./DMAcc/lawmo/AppAuth/ClientAppAuth/AAuthData"
#define LAWMO_DM_ACC_APPAUTH_X2									"./DMAcc/lawmo/AppAuth/ServerAppAuth"
#define LAWMO_DM_ACC_APPAUTH_X2_AAUTHLEVEL				"./DMAcc/lawmo/AppAuth/ServerAppAuth/AAuthLevel"
#define LAWMO_DM_ACC_APPAUTH_X2_AAUTHTYPE					"./DMAcc/lawmo/AppAuth/ServerAppAuth/AAuthType"
#define LAWMO_DM_ACC_APPAUTH_X2_AAUTHNAME				"./DMAcc/lawmo/AppAuth/ServerAppAuth/AAuthName"
#define LAWMO_DM_ACC_APPAUTH_X2_SECRET						"./DMAcc/lawmo/AppAuth/ServerAppAuth/AAuthSecret"
#define LAWMO_DM_ACC_APPAUTH_X2_AAUTHDATA					"./DMAcc/lawmo/AppAuth/ServerAppAuth/AAuthData"
#define LAWMO_DM_ACC_EXT													"./DMAcc/lawmo/Ext"

#define DM_DEVINFO													"./DevInfo"
#define DM_DEVINFO_BEARER									"./DevInfo/Bearer"
#define DM_DEVINFO_DEVID										"./DevInfo/DevId"
#define DM_DEVINFO_MAN											"./DevInfo/Man"
#define DM_DEVINFO_MOD										"./DevInfo/Mod"
#define DM_DEVINFO_DMV											"./DevInfo/DmV"
#define DM_DEVINFO_LANG										"./DevInfo/Lang"
#define DM_DEVINFO_EXT											"./DevInfo/Ext"

#define DM_DEVDETAIL												"./DevDetail"
#define DM_DEVDETAIL_BEARER									"./DevDetail/Bearer"
#define DM_DEVINFO_URI											"./DevDetail/URI"
#define DM_DEVINFO_URI_MAXDEPTH							"./DevDetail/URI/MaxDepth"
#define DM_DEVINFO_URI_MAXTOTLEN						"./DevDetail/URI/MaxTotLen"
#define DM_DEVINFO_URI_MAXSEGLEN						"./DevDetail/URI/MaxSegLen"
#define DM_DEVINFO_DEVTYP										"./DevDetail/DevTyp"
#define DM_DEVINFO_OEM											"./DevDetail/OEM"
#define DM_DEVINFO_FWV											"./DevDetail/FwV"
#define DM_DEVINFO_SWV											"./DevDetail/SwV"
#define DM_DEVINFO_HWV											"./DevDetail/HwV"
#define DM_DEVINFO_LRGOBJ									"./DevDetail/LrgObj"

/*temp length*/
#define MO_MAX_LEN												100

#define DM_FUMO																	"./FUMO"
#define DM_FUMO_PKGNAME													"./FUMO/PkgName"
#define DM_FUMO_VERSION													"./FUMO/PkgVersion"
#define DM_FUMO_DOWNLOAD												"./FUMO/Download"
#define DM_FUMO_DWONLOAD_PKGURL								"./FUMO/Download/PkgURL"
#define DM_FUMO_UPDATE													"./FUMO/Update"
#define DM_FUMO_UPDATE_PKG_DATA									"./FUMO/Update/PkgData"
#define DM_FUMO_DOWNLOADAND_UPDATE							"./FUMO/DownloadAndUpdate"
#define DM_FUMO_DOWNLOADAND_UPDATE_PKGURL				"./FUMO/DownloadAndUpdate/PkgURL"
#define DM_FUMO_STATE														"./FUMO/State"
#define DM_FUMO_EXT															"./FUMO/Ext"

#define DM_FUMO_EXT_DO_CHECKING_ROOTING				"./FUMO/Ext/DoCheckingRooting"

#define DM_LAWMO																"./LAWMO"
#define DM_LAWMO_STATE													"./LAWMO/State"
#define DM_LAWMO_AVAILABLEWIPELIST									"./LAWMO/AvailableWipeList"
#define DM_LAWMO_AVAILABLEWIPELIST_x1							"./LAWMO/AvailableWipeList/x1"
#define DM_LAWMO_AVAILABLEWIPELIST_x1_LISTITEMNAME	"./LAWMO/AvailableWipeList/x1/ListItemName"
#define DM_LAWMO_AVAILABLEWIPELIST_x1_TOBEWIPED			"./LAWMO/AvailableWipeList/x1/ToBeWiped"
#define DM_LAWMO_LAWMOCONFIG										"./LAWMO/LAWMOConfig"
#define DM_LAWMO_LAWMOCONFIG_NOFITYUSER					"./LAWMO/LAWMOConfig/NotifyUser"
#define DM_LAWMO_OPERATIONS											"./LAWMO/Operations"
#define DM_LAWMO_OPERATIONS_FULLYLOCK						"./LAWMO/Operations/FullyLock"
#define DM_LAWMO_OPERATIONS_PARTIALLYLOCK					"./LAWMO/Operations/PartiallyLock"
#define DM_LAWMO_OPERATIONS_UNLOCK							"./LAWMO/Operations/UnLock"
#define DM_LAWMO_OPERATIONS_FACTORYRESET					"./LAWMO/Operations/FactoryReset"
#define DM_LAWMO_OPERATIONS_WIPE									"./LAWMO/Operations/Wipe"
#define DM_LAWMO_EXT														"./LAWMO/Ext"

#define DM_LAWMO_EXT_OSPS																									"./Ext/OSPS"
#define DM_LAWMO_EXT_OSPS_LAWMO																						"./Ext/OSPS/LAWMO"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP																				"./Ext/OSPS/LAWMO/OSP"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_STATE																	"./Ext/OSPS/LAWMO/OSP/State"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_X																			"./Ext/OSPS/LAWMO/OSP/<x>"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_LAWMOCONFIG														"./Ext/OSPS/LAWMO/OSP/LAWMOConfig"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_NOTIFYUSER															"./Ext/OSPS/LAWMO/OSP/NotifyUser"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS															"./Ext/OSPS/LAWMO/OSP/Operations"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS_FULLYLOCK										"./Ext/OSPS/LAWMO/OSP/Operations/FullyLock"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS_PARTIALLYLOCK								"./Ext/OSPS/LAWMO/OSP/Operations/PartiallyLock"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS_UNLOCK											"./Ext/OSPS/LAWMO/OSP/Operations/UnLock"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS_FACTORYRESET									"./Ext/OSPS/LAWMO/OSP/Operations/FactoryReset"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_OPERATIONS_WIPE												"./Ext/OSPS/LAWMO/OSP/Operations/Wipe"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT																		"./Ext/OSPS/LAWMO/OSP/Ext"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_AMT																"./Ext/OSPS/LAWMO/OSP/Ext/AMT"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_STATUS															"./Ext/OSPS/LAWMO/OSP/Ext/AMT/Status"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_LOCKMYPHONE_MESSAGES							"./Ext/OSPS/LAWMO/OSP/Ext/LockMyPhone/Messages"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_CALLRESTRICTION_PHONENUMBER					"./Ext/OSPS/LAWMO/OSP/Ext/CallRestriction/PhoneNumber"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_PASSWORD													"./Ext/OSPS/LAWMO/OSP/Ext/Password"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_AVAILABLEWIPELIST												"./Ext/OSPS/LAWMO/OSP/AvailableWipeList"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_AVAILABLEWIPELIST_EXTERNAL_LISTITEMNAME		"./Ext/OSPS/LAWMO/OSP/AvailableWipeList/External/ListItemName"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_AVAILABLEWIPELIST_EXTERNAL_TOBEWIPED			"./Ext/OSPS/LAWMO/OSP/AvailableWipeList/External/ToBeWiped"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_AVAILABLEWIPELIST_SIM_LISTITEMNAME				"./Ext/OSPS/LAWMO/OSP/AvailableWipeList/SIM/ListItemName"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_AVAILABLEWIPELIST_SIM_TOBEWIPED						"./Ext/OSPS/LAWMO/OSP/AvailableWipeList/SIM/ToBeWiped"

#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_RINGMYPHONE_OPERATIONS_START				"./Ext/OSPS/LAWMO/OSP/Ext/RingMyPhone/Operations/Start"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_RINGMYPHONE_OPERATIONS_STOP					"./Ext/OSPS/LAWMO/OSP/Ext/RingMyPhone/Operations/Stop"
#define DM_LAWMO_EXT_OSPS_LAWMO_OSP_EXT_RINGMYPHONE_STATUS									"./Ext/OSPS/LAWMO/OSP/Ext/RingMyPhone/Status"

#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_ISVALID													"./Ext/OSPS/MobileTraking/GPS/isValid"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_LATITUDE													"./Ext/OSPS/MobileTraking/GPS/latitude"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_LONGITUDE												"./Ext/OSPS/MobileTraking/GPS/longitude"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_HORIZONTALUNCERTAINTY						"./Ext/OSPS/MobileTraking/GPS/horizontalUncertainty"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_VERTICALUNCERTAINTY								"./Ext/OSPS/MobileTraking/GPS/verticalUncertainty"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_GPS_DATE														"./Ext/OSPS/MobileTraking/GPS/Date"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS															"./Ext/OSPS/MobileTraking/NonGPS"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS_ISVALID												"./Ext/OSPS/MobileTraking/NonGPS/isValid"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS_CELLID												"./Ext/OSPS/MobileTraking/NonGPS/CellId"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS_LAC													"./Ext/OSPS/MobileTraking/NonGPS/LAC"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS_MNC													"./Ext/OSPS/MobileTraking/NonGPS/MNC"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_NONGPS_MCC													"./Ext/OSPS/MobileTraking/NonGPS/MCC"

#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_OPERATION														"./Ext/OSPS/MobileTraking/Operation"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_OPERATION_GET												"./Ext/OSPS/MobileTraking/Operation/Get"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_OPERATION_GET_LOCATION								"./Ext/OSPS/MobileTraking/Operation/Get/Location"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_OPERATION_STOP											"./Ext/OSPS/MobileTracking/Operations/Stop"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_OPERATION_TRACKING										"./Ext/OSPS/MobileTracking/Operations/Tracking"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_STATUS															"./Ext/OSPS/MobileTracking/Status"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_POLICY															"./Ext/OSPS/MobileTracking/Policy"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_POLICY_STARTDATE											"./Ext/OSPS/MobileTracking/Policy/StartDate"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_POLICY_ENDDATE												"./Ext/OSPS/MobileTracking/Policy/EndDate"
#define DM_LAWMO_EXT_OSPS_MOBILETRAKING_POLICY_INTERVAL												"./Ext/OSPS/MobileTracking/Policy/Interval"

#define DM_LAWMO_EXT_OSPS_FORWARDING																			"./Ext/OSPS/Forwarding"
#define DM_LAWMO_EXT_OSPS_FORWARDING_NUMBERS_CALLFORWARDING								"./Ext/OSPS/Forwarding/Numbers/CallForwarding"
#define DM_LAWMO_EXT_OSPS_FORWARDING_ENABLEDSERVICES_CALLFORWARDING					"./Ext/OSPS/Forwarding/EnabledServices/CallForwarding"
#define DM_LAWMO_EXT_OSPS_FORWARDING_NUMBERS_SMSFORWARDING								"./Ext/OSPS/Forwarding/Numbers/SMSForwarding"
#define DM_LAWMO_EXT_OSPS_FORWARDING_ENABLEDSERVICES_SMSFORWARDING					"./Ext/OSPS/Forwarding/EnabledServices/SMSForwarding"
#define DM_LAWMO_EXT_OSPS_FORWARDING_OPERATIONS_DIVERTREQUEST								"./Ext/OSPS/Forwarding/Operations/DivertRequest"
#define DM_LAWMO_EXT_OSPS_MASTERKEY_OPERATIONS															"./Ext/OSPS/MasterKey/Operations"
#define DM_LAWMO_EXT_OSPS_MASTERKEY_OPERATIONS_LOCKRELEASE									"./Ext/OSPS/MasterKey/Operations/LockRelease"

#endif

#endif				/* DM_MO_GENERATER_INTERNAL_H_ */
