/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef NA_BINDER_H_
#define NA_BINDER_H_

/*sync-agent*/
#include <sync_agent.h>

/*dm-agent*/
#include "serviceadapter/sa_define.h"

#define HTTP_X_SYNCML_HMAC			"x-syncml-hmac"
#define HTTP_COOKIE							"cookie"

/**
 * @par Description: API to send msg oma sepc, syncml sepc
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
  * @param[in]	accType			(obex, http ...)
  * @param[in]	loc_uri 			server url
  * @param[in]	sesion id		session id
  * @param[in]	is_hmac			is hmac
  * @param[in]	username		username
  * @param[in]	list 				header list
 *
 *
 * @return				1								success
 *							o 								fail
 *
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int NA_http_header_binder(char *accType, char *loc_uri, char *sessionid, int isHMAC, char *username, char *mac, GList ** list);

/**
 * @par Description: API to send msg oma sepc, syncml sepc
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @param[in]	receive header			receive header
 * @param[in]	temp jsessionid 			temp jsession id
 * @param[out] real jsession id			real jsession id
 * @param[out]	other cookie				other cookie (not use)
 *
 *
 * @return				1								success
 *							o 								fail
 *
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
int add_jsession_in_httpheader(GList * recv_header, char *temp_jsessionid, char **real_jsessionid, char **real_other_cookie);

#endif				/* NA_BINDER_H_ */
