/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef SYNCML_DEFIINE_H_
#define SYNCML_DEFIINE_H_

/*
 * Common Use Elements
 */
#define ELEMENT_CHAL "Chal"
#define ELEMENT_CMD "Cmd"
#define ELEMENT_CMDID "CmdID"
#define ELEMENT_CMDREF "CmdRef"
#define ELEMENT_CRED "Cred"
#define ELEMENT_FINAL "Final"
#define ELEMENT_LOCNAME "LocName"
#define ELEMENT_LOCURI "LocURI"
#define ELEMENT_MOREDATA "MoreData"
#define ELEMENT_MSGID "MsgID"
#define ELEMENT_MSGREF "MsgRef"
#define ELEMENT_RESPURI "RespURI"
#define ELEMENT_SESSIONID "SessionID"
#define ELEMENT_SOURCE "Source"
#define ELEMENT_SOURCEREF "SourceRef"
#define ELEMENT_TARGET "Target"
#define ELEMENT_TARGETREF "TargetRef"
#define ELEMENT_VERDTD "VerDTD"
#define ELEMENT_VERPROTO "VerProto"
/*
 *  Msg Container Elements
 */
#define ELEMENT_SYNCML "SyncML"
#define ELEMENT_SYNCHDR "SyncHdr"
#define ELEMENT_SYNCBODY "SyncBody"
/*
 * Data Description Elements
  */
#define ELEMENT_DATA "Data"
#define ELEMENT_ITEM "Item"
#define ELEMENT_META "Meta"
#define ELEMENT_CORRELATOR "Correlator"
/*
 * Meta Infomation Elements
 */
#define ELEMENT_EMI "EMI"
#define ELEMENT_FORMAT "Format"
#define ELEMENT_MAXMSGSIZE "MaxMsgSize"
#define ELEMENT_MAXOBJSIZE "MaxObjSize"
#define ELEMENT_METAINF "MetaInf"
#define ELEMENT_NEXTNONCE "NextNonce"
#define ELEMENT_SIZE "Size"
#define ELEMENT_TYPE "Type"
/*
 * Protocol Mangement Elements
 */
#define ELEMENT_STATUS "Status"
/*
 * Protocol Command Elements
 */
#define ELEMENT_ADD "Add"
#define ELEMENT_ATOMIC "Atomic"
#define ELEMENT_COPY "Copy"
#define ELEMENT_DELETE "Delete"
#define ELEMENT_EXEC "Exec"
#define ELEMENT_GET "Get"
#define ELEMENT_REPLACE "Replace"
#define ELEMENT_SEQUENCE "Sequence"
#define ELEMENT_ALERT "Alert"
#define ELEMENT_RESULTS "Results"
/*
 * VERDTD
 * VERProto
 */
#define ELEMENT_VERDTD_10 "1.0"
#define ELEMENT_VERDTD_11 "1.1"
#define ELEMENT_VERDTD_12 "1.2"
#define ELEMENT_VERPROTO_10 "DM/1.0"
#define ELEMENT_VERPROTO_11 "DM/1.1"
#define ELEMENT_VERPROTO_12 "DM/1.2"
/*
 *Authentication
 */
#define ELEMENT_AUTH_BASIC "syncml:auth-basic"
#define ELEMENT_AUTH_MD5 "syncml:auth-md5"
#define ELEMENT_AUTH_HMAC "syncml:auth-MAC"
#define ELEMENT_FORMAT_BASE64 "b64"
/*
 * will delete
 */
#define ELEMENT_NUMBEROFCHANGES "NumberOfChanges"
#define ELEMENT_LAST "Last"
#define ELEMENT_NEXT "Next"

#define ELEMENT_B64	"b64"
#define ELEMENT_BIN	"bin"
#define ELEMENT_BOOL	"bool"
#define ELEMENT_CHR	"chr"
#define ELEMENT_INT	"int"
#define ELEMENT_NULL	"null"
#define ELEMENT_XML	"xml"
#define ELEMENT_DATE	"date"
#define ELEMENT_TIME	"time"
#define ELEMENT_FLOAT "float"
#define ELEMENT_NODE	 "node"

#define ELEMENT_TEXT_PLAIN	"text/plain"

typedef enum {
	PE_UNDEF = 0,
	PE_ERROR = 1,
	PE_ADD = 2,
	PE_ALERT = 3,
	PE_ATOMIC_START = 4,
	PE_ATOMIC_END = 5,
	PE_COPY = 6,
	PE_DELETE = 7,
	PE_EXEC = 8,
	PE_GET = 9,
	PE_RESULTS_END = 10,
	PE_RESULTS_START = 11,
	PE_SEARCH = 12,
	PE_SEQUENCE_START = 13,
	PE_SEQUENCE_END = 14,
	PE_STATUS = 15,
	PE_SYNC_START = 16,
	PE_SYNC_END = 17,
	PE_REPLACE = 18,
	PE_HEADER = 19,
	PE_GENERIC = 20,
	PE_FINAL = 21,
	PE_SYNCML_START = 22,
	PE_SYNCML_END = 23,
	PE_BODY_START = 24,
	PE_BODY_END = 25,
	PE_SEQUENCE = 26,
	PE_ATOMIC = 27
} OMA_DM_Protocol_Element;

#endif				/* SYNCML_DEFIINE_H_ */
