/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef SA_SESSION_INTERNAL_H_
#define SA_SESSION_INTERNAL_H_

/*dm-agent*/
#include "common/dm_common_def.h"
#include "serviceadapter/sa_define.h"

struct Session {
	ProtocolVersion protocolVersion;
	ProtocolType protocolType;

	char *sessionID;
	unsigned int msgID;
	unsigned int lastRecievedMsgID;
	unsigned int cmdID;
	int isSendingfinal;
	int isReceivingFinal;

	GList *status;		//status to return to server
	GList *tempStatus;	//temp status for sync add, replace, delete command(it does not have data element value)

	Location *target;
	Location *source;
	Location *orgTarget;

	unsigned int sourceMaxMsgSize;
	unsigned int sourceMaxObjSize;

	unsigned int targetMaxMsgSize;
	unsigned int targetMaxObjSize;

	int accountId;

	char *pServer_id;	//server id
	ENGINE_ID service_engine_id;	//service engine id

	Cred *cred;		//account info
	Chal *res_chal;		//res_chal from server to client
	Chal *req_chal;		//req_chal from clinet to server

	int isHMAC;		//using HMAC authentication
	Hmac *reqhmacinfo;	//hmac info for http header
	Hmac *resphmacinfo;	//hmac info for http header

	char *jsessionid;	//lawmo jsession
	char *other_cookie;
	GList *pendingStatus;	//containing pendingStatus structure ->msgid and cmd id that sent to server

	Command *pLargeObjCmd;	//for incomming large Command
	GList *alertCommand;	//containing alert command that have to send to server
	GList *resultsCommand;	//containing results command

};

struct PendingStatus {
	unsigned int cmdID;
	unsigned int msgID;
	// callback;
	//userdata;
};
#endif				/* SA_SESSION_INTERNAL_H_ */
