/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef SA_BINDERS_H_
#define SA_BINDERS_H_

/*dm-agent*/
#include "common/dm_error.h"
#include "serviceadapter/sa_define.h"

/**
 * @par Description: API to create syncml object binder
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[in]		Syncml structure
 * @param[out]		string type, msg
 * @param[out]		msg size
 *
 * @return				DM_OK on success
 *							DM_ERROR on fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
DM_ERROR syncml_objectbinder(SyncML * pSyncML, char **msg, unsigned int *msg_size);

/**
 * @par Description: API to reverse syncml object binder
 *
 *
 * @par Purpose:
 * @par Typical use case:
 * @par Method of function operation:
 * @par Important notes:
 * @param[out]		Syncml structure
 * @param[out]		string type, recieve msg
 * @param[out]		int type, recieve msg size
 * @param[out]		string type, xml
 * @param[out]		int type, xml  size
 *
 * @return				DM_OK on success
 *							DM_ERROR on fail
 *
 * @par Errors:
 *
 * @pre None.
 * @post
 * @see
 * @remarks None.
 *
 * @par Sample Code:
 * @code
 * @endcode
 */
DM_ERROR reverse_syncml_objectbinder(SyncML ** pSyncML, char *recv_msg, unsigned int recv_msg_length, char **xml, unsigned int *xml_len);

#endif				/* SA_BINDERS_H_ */
