Name:       oma-dm-agent
Summary:    oma-dm-agent daemon for FOTA,DM,CP,FMM Service
Version:    0.1.69
Release:    1
Group:      Base/Device Management
License:    Apache-2.0
Source0:    oma-dm-agent-%{version}.tar.gz

#Requires(post): /sbin/ldconfig
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  pkgconfig(libsoup-2.4)
BuildRequires:  pkgconfig(vconf)
BuildRequires:  pkgconfig(libwbxml2)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(check)
BuildRequires:  pkgconfig(sync-agent)
BuildRequires:  pkgconfig(aul)
BuildRequires:  pkgconfig(appsvc)
BuildRequires:  pkgconfig(push)
BuildRequires:  pkgconfig(sysman)
BuildRequires:  pkgconfig(capi-base-common)
BuildRequires:  pkgconfig(bundle)
BuildRequires:  pkgconfig(location)
BuildRequires:  pkgconfig(tapi)
BuildRequires:  pkgconfig(pmapi)
BuildRequires:  pkgconfig(capi-system-info)
BuildRequires:  pkgconfig(capi-telephony-sim)
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(dbus-glib-1)
#BuildRequires:  pkgconfig(oauth)
#BuildRequires:  pkgconfig(samsung-sso-svc)
	
#BuildRequires:  pkgconfig(appcore-efl)
#BuildRequires:  pkgconfig(appcore-common)
BuildRequires:  libgcrypt-devel
BuildRequires:  expat-devel
BuildRequires:  cmake


%description
oma-dm-agent Daemon servcie

%package -n dm-private-plugins
Summary:    DM Private Plugins
Group:      Base/Device Management

%description -n dm-private-plugins
dm private plugins for sync-agent

%package -n dm-public-plugins
Summary:    DM Public Plugins
Group:      Base/Device Management

%description -n dm-public-plugins
dm public plugins for sync-agent

%prep
%setup -q


%build
cmake . -DCMAKE_INSTALL_PREFIX=%{_prefix}
make %{?jobs:-j%jobs}


%install
rm -rf %{buildroot}

if [ ! -d %{buildroot}/opt/usr/dbspace ]
then
	mkdir -p %{buildroot}/opt/usr/dbspace
fi

sqlite3 %{buildroot}/opt/usr/dbspace/.dm_service.db "PRAGMA journal_mode = PERSIST; create table a(a); drop table a;" > /dev/null
sqlite3 %{buildroot}/opt/usr/dbspace/.omadmagent.db "PRAGMA journal_mode = PERSIST; create table a(a); drop table a;" > /dev/null
sqlite3 %{buildroot}/opt/usr/dbspace/.momanager.db "PRAGMA journal_mode = PERSIST; create table a(a); drop table a;" > /dev/null

%make_install


%clean
rm -rf %{buildroot}


%post


%preun


%postun

rm -f /tmp/agent_fw_event_omadm*
rm -f /tmp/agent_fw_noti_reply_omadm*

rm -f /opt/usr/dbspace/.dm_service.db /opt/usr/dbspace/.dm_service.db-journal
rm -f /opt/usr/dbspace/.omadmagent.db /opt/usr/dbspace/.omadmagent.db-journal
rm -f /opt/usr/dbspace/.momanager.db /opt/usr/dbspace/.momanager.db-journal

rm -rf /usr/share/oma-dm-cfg


%files
%attr(600,root,root) /opt/usr/dbspace/.dm_service.db
%attr(600,root,root) /opt/usr/dbspace/.dm_service.db-journal
%attr(600,root,root) /opt/usr/dbspace/.omadmagent.db
%attr(600,root,root) /opt/usr/dbspace/.omadmagent.db-journal
%attr(600,root,root) /opt/usr/dbspace/.momanager.db
%attr(600,root,root) /opt/usr/dbspace/.momanager.db-journal

%manifest oma-dm-agent.manifest
%defattr(-,root,root,-)
/usr/share/dbus-1/system-services/com.samsung.omadmagent.service
/etc/dbus-1/system.d/com.samsung.omadmagent.conf
/usr/bin/oma-dm-agent

/usr/share/oma-dm-cfg/ddf/*
/usr/share/oma-dm-cfg/delta_size/*
/usr/share/oma-dm-cfg/fw-init/*
/usr/share/oma-dm-cfg/ipc/*


%defattr(700,root,root)
/usr/share/oma-dm-cfg/csc-setting/change_csc_value.sh
/usr/share/oma-dm-cfg/imei-setting/change_imei_callnum.sh

%files -n dm-private-plugins
%manifest dm-private-plugins.manifest
%defattr(-,root,root,-)
/usr/lib/sync-agent/dm-private/*
/usr/include/sync-agent/plugin/plugin_slp_device_dm.h

%files -n dm-public-plugins
%manifest dm-public-plugins.manifest
%defattr(-,root,root,-)
/usr/lib/sync-agent/dm-public/*

