/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*lib*/
#include <stdlib.h>
#include <string.h>

/*sync-agent*/
#include <sync_agent.h>

/*dm-agent*/
#include "dm-engine/dl-manager/na_fw_dl_binder.h"

#ifndef OMADM_AGENT_LOG
#undef LOG_TAG
#define LOG_TAG	"OMA_DM_DL"
#endif

void add_header_info(GList ** header_info_list, char *key, char *value)
{
	_EXTERN_FUNC_ENTER;

	retm_if((key) == NULL, "key is NULL!!");
	retm_if((value) == NULL, "value is NULL!!");

	if (value != NULL) {
		sync_agent_na_common_header_info_s *header_info = (sync_agent_na_common_header_info_s *) calloc(1, sizeof(sync_agent_na_common_header_info_s));
		if (header_info == NULL) {
			_DEBUG_INFO("alloc error");
			return;
		}
		header_info->key = key;
		header_info->value = value;
		*header_info_list = g_list_append(*header_info_list, header_info);
	}

	_EXTERN_FUNC_EXIT;
}
