/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*sync-agent*/
#include <sync_agent.h>

/*dm-agent*/
#include "common/dm_common.h"
#include "dm-engine/lawmo/lawmo_account.h"

#ifndef OMADM_AGENT_LOG
#undef LOG_TAG
#define LOG_TAG	"LAWMO_ENGINE"
#endif

int register_lawmo_account(int item_id, void *user_data)
{
	_EXTERN_FUNC_ENTER;

	int ret = 1;
	sync_agent_dm_mo_error_e err = 1;
	int count = 0;
	int value = 0;

/*int db_ret = 0;
 * db_ret = sync_agent_open_agent();
	_DEBUG_INFO("OPEN DACI : %d", db_ret);*/

	set_alarm_config_int(LAWMO_ACCOUNT_FLAG_TYPE, LAWMO_ACCOUNT_FLAG, 0, LAWMO_ENGINE);
	value = get_config_int(LAWMO_ACCOUNT_FLAG_TYPE, LAWMO_ACCOUNT_FLAG);

	_DEBUG_INFO("lawmo account flag : %d ", value);

	if (value != 1) {
		do {
			err = sync_agent_initialize_mo(7);
			if (err == SYNC_AGENT_DM_MO_FAIL) {
				_DEBUG_INFO("fail register lawmo account : %d ", err);
				ret = 0;
			} else {
				_DEBUG_INFO("success register lawmo account : %d ", err);
				break;
			}
			count++;
		} while (err == SYNC_AGENT_DM_MO_FAIL && count < 3);

		if (err == SYNC_AGENT_DM_MO_FAIL) {
			_DEBUG_INFO("add lawmo account registration alarm : %d ", ret);
			ret = set_account_registration_alarm(LAWMO_ACCOUNT_ALARM, LAWMO_ACCOUNT_ALARM_TYPE);
			_DEBUG_INFO("set account registration alarm lawmo account : %d ", ret);
			ret = 0;
		} else {
			ret = set_config_int(LAWMO_ACCOUNT_FLAG_TYPE, LAWMO_ACCOUNT_FLAG, 1, LAWMO_ENGINE, 0);
			_DEBUG_INFO("add lawmo account flag type setting result : %d ", ret);
			delete_account_registration_alarm(LAWMO_ACCOUNT_ALARM, LAWMO_ACCOUNT_ALARM_TYPE);
			_DEBUG_INFO("delete lawmo account delete alarm");
		}
	} else {
		//do nothing
	}

/*	db_ret = sync_agent_close_agent();
	_DEBUG_INFO("CLOSE DACI : %d", db_ret);*/

	_DEBUG_INFO("end : %d", ret);
	_EXTERN_FUNC_EXIT;
	return ret;
}

int deregister_lawmo_account(int item_id, void *user_data)
{
	_EXTERN_FUNC_ENTER;
	int ret = 1;

	ret = sync_agent_open_agent();
	_DEBUG_INFO("OPEN DACI : %d", ret);

	//set_alarm_config_int(LAWMO_ACCOUNT_FLAG_TYPE, LAWMO_ACCOUNT_FLAG, 0, LAWMO_ENGINE);
	set_config_int(LAWMO_ACCOUNT_FLAG_TYPE, LAWMO_ACCOUNT_FLAG, 0, LAWMO_ENGINE, 0);
	_DEBUG_INFO("lawmo account flag 0");

	ret = sync_agent_close_agent();
	_DEBUG_INFO("CLOSE DACI : %d", ret);

	_EXTERN_FUNC_EXIT;
	return ret;
}
