/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <crypt.h>

/*sync-agent*/
#include <sync_agent.h>

#include "password_generator.h"

#ifndef OMADM_AGENT_LOG
#undef LOG_TAG
#define LOG_TAG	"PLUGIN_DMACC_GCF"
#endif

#define MAX_LENGTH 32

/* general function */
// RSA -----------------------------------         gcf common - generate_password... 
char *generate_device_password(const char *imei_device_id, const char *server_id, generate_type type)
{

	_EXTERN_FUNC_ENTER;

	retvm_if((imei_device_id) == NULL, 0, "imei_device_id is NULL!!");
	retvm_if((server_id) == NULL, 0, "server_id is NULL!!");

	char *password = NULL;

	_DEBUG_INFO("imei_device_id = %s, server_id = %s\n", imei_device_id, server_id);
	password = g_strdup_printf("%s_pw", server_id);

	//// password generate ///

	//////////////////////////

	_EXTERN_FUNC_EXIT;

	return password;
}

/*
static void __print__array(char *array, int array_length, char *array_name)
{
	_DEBUG_VERBOSE(" ====> Array Name : %s <===== \n", array_name);
	int i;
	for (i = 0; i < array_length; i++) {
		_DEBUG_VERBOSE("index[ %d] = %X, ", i, array[i]);
		if (i != 0 && 0 == (i % 8)) {
			_DEBUG_VERBOSE("\n");
		}
	}
	_DEBUG_VERBOSE("\n");
}
*/
