/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef PLUGIN_DEVEXE_ERROR_H_
#define PLUGIN_DEVEXE_ERROR_H_

/* depend slp-device-plugIn lib */
typedef enum {

	EXE_SUCCESS = 1,
	EXE_DEV_FAIL = -1,

	/* standard error */
	EXE_DEV_DATA_FAIL = -2,
	EXE_DEV_OPER_NOT_PERFORMED = -3,

	/* vender specific error */

	/*common */
	EXE_DEV_AMT_STATUS_OFF = -4,
	EXEC_DEV_SCREEN_OFF = -5,

	/*wipe */
	EXE_DEV_WIPE_ALL_FAILED = -10,
	EXE_DEV_EXTERNAL_MEMORY_FAILED = -11,
	EXE_DEV_SIM_MEMORY_FAILED = -12,

	/*forwarding */
	EXE_DEV_FORWORDING_ALL_FAILED = -20,
	EXE_DEV_FORWORDING_CALL_FAILED = -21,
	EXE_DEV_FORWORDING_SMS_FAILED = -22
} slp_device_dm_exe_e;

typedef enum {

	OPERATION_SUCCEEDED = 1200,
	WIPE_OPEARTION_SUCCEEDED_WITH_DATA_WIPED = 1201,
	WIPE_OPERATION_SUCCEEDED_WITH_BOTH_DATA_AND_ASSOCIATED_WIPE_LIST_WITHIN_MANAGEMENT_TREE_WIPED = 1202,

	/*SUCCESSFUL = VENDOR SPECIFIED */
	SUCCESSFUL_SAME_STATUS = 1250,

	 /*ERROR*/ CLIENT_ERROR = 1400,
	USER_CANCELLED = 1401,

	/* Lock & Wipe */
	FULLY_LOCK_DEVICE_FAILED = 1402,
	PARTIALLY_LOCK_DEVICE_FAILED = 1403,
	UNLOCK_DEVICE_FAILED = 1404,
	WIPE_DEVICES_DATA_FAILED = 1405,
	WIPE_OPERATION_NOT_PERFORMED = 1406,

	CLIENT_TIME_EXPIRED = 1451,

	/* Ring My Phone */
	AMT_STATUS_OFF = 1452,
	/* Location */

	/* MasterKey */
	SCREEN_OFF = 1453,

	/* Wipe */
	EXTERNAL_AND_SIM_MEMORY_WIPE_FAILED = 1460,
	EXTERNAL_MEMORY_WIPE_FAILED = 1461,
	SIM_MEMORY_WIPE_FAILED = 1462,

	/* Forwarding */
	CALL_AND_SMS_FORWARDING_FAILED = 1470,
	CALL_FORWARDING_FAILED = 1471,
	SMS_FORWARDING_FAILED = 1472,

} ext_lawmo_e;

/*
1400	Client Error
1401	User Canceled
1402	Fully Lock Device Failed
1403	Partially Lock Device Failed
1404	Unlock Device Failed
1405	Wipe Device Data Failed
1406	Wipe Operation Not Performed
1451	Client Time Expired
1452	AMT Status Off
1453	Screen Off
1460	External and SIM memory wipe Failed
1461	External memory wipe Failed
1462	SIM memory wipe Failed
1470	Call and SMS forwarding Failed
1471	Call forwarding Failed
1472	SMS forwarding Failed
*/

#endif				/* PLUGIN_DEVEXE_ERROR_H_ */
