/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef PLUGIN_DEVEXE_ERROR_H_
#define PLUGIN_DEVEXE_ERROR_H_

typedef enum {

	EXE_SUCCESS = 1,
	EXE_DEV_FAIL = -1,

	/* standard error */
	EXE_DEV_DATA_FAIL = -2,
	EXE_DEV_OPER_NOT_PERFORMED = -3,

	/* vender specific error */

	/*common */
	EXE_DEV_AMT_STATUS_OFF = -4,
	EXEC_DEV_SCREEN_OFF = -5,

	/*wipe */
	EXE_DEV_WIPE_ALL_FAILED = -10,
	EXE_DEV_EXTERNAL_MEMORY_FAILED = -11,
	EXE_DEV_SIM_MEMORY_FAILED = -12,

	/*forwarding */
	EXE_DEV_FORWORDING_ALL_FAILED = -20,
	EXE_DEV_FORWORDING_CALL_FAILED = -21,
	EXE_DEV_FORWORDING_SMS_FAILED = -22
} slp_device_dm_exe_e;

#endif				/* PLUGIN_DEVEXE_ERROR_H_ */
