/*
 * oma-dm-agent
 * Copyright (c) 2012 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef PLUGIN_SLP_DEVICE_DM_H_
#define PLUGIN_SLP_DEVICE_DM_H_

/*
 *	list of device information on SLP
 */

/*
 * < OMA DM >
 *  1. DevInfo
 *  - DevID : device id
 *  - Man : manufacture
 *  - Mod : model id or model number
 *  - DmV : OMA DM client version
 *  - Lang : current setting language
 *  - Bearer : bearer
 *
 *  2. DevDetail
 *  - KernelV : kernel version
 *  - SwV : software version
 *  - HwV : hardware version
 *  - FwV : firmware version
 *  - ModemV : modem version
 *  - PDAV : PDA version
 *  - OEM : original equipment manufacturer
 *  - DevType : device type
 *  - Bearer : bearer
 *  - FOTADownDir : firmware download directory
 *  - FOTASaveDir : firmware save directory
 *  - Battery : battery level
 *  - MCC :contry code
 *  - CSC:
 */

/**
 * @brief Enumerations for state of power manager
 */
typedef enum {
	LCD_NORMAL = 0,
	LCD_DIM,
	LCD_OFF,
	SUSPEND,
	POWER_OFF,
	SETALL
} pm_state_e;

/**
 * @brief Enumerations for lock state of power manager
 */
typedef enum {
	GOTO_STATE_NOW = 0,
	STAY_CUR_STATE
} pm_lock_state_flag_e;

/**
 * @brief Enumerations for unlock state of power manager
 */
typedef enum {
	SLEEP_MARGIN = 0,
	RESET_TIMER,
	KEEP_TIMER
} pm_unlock_state_flag_e;

#endif				/* PLUGIN_SLP_DEVICE_DM_H_ */
